﻿# -*- coding: utf-8 -*-

import os, sys, time, shutil, subprocess, csv
reload(sys)
sys.setdefaultencoding(sys.getfilesystemencoding())
from Tkinter import *
from tkFileDialog import *
import tkMessageBox
import ttk

sys.dont_write_bytecode = True
easi_path = sys.executable.replace('pythonw','python')
app_title = 'KOMPSAT Pansharpening Processor'
app_version = 'v20160615'
app_icon = 'icon.ico'
lastdir = '.'

class FolderDialog:

    def __init__(self, master, initialdir='.'):
        self.master = Toplevel(master)
        self.master.protocol('WM_DELETE_WINDOW', self.quit_process)
        self.master.title('폴더 찾아보기')
        self.master.geometry('600x800')
        self.result = ''

        # 최상단 레이블
        frameLabel = ttk.Frame(self.master, pad=5)
        ttk.Label(frameLabel, text='디렉토리를 선택하십시오').pack(side=LEFT)
        frameLabel.pack(side=TOP, fill=X)
        
        # 상단 디렉토리 레이블
        frameEntry = ttk.Frame(self.master, pad=5)
        self.stringDir = StringVar(value='')
        labelDir = Label(frameEntry, textvariable=self.stringDir)
        labelDir.pack(side=LEFT)
        frameEntry.pack(side=TOP, fill=X)
        
        # 메인 디렉토리 트리
        frameTree = ttk.Frame(self.master, pad=5)
        frameTree.pack(side=TOP, fill=BOTH, expand=Y)
         
        self.tree = ttk.Treeview(frameTree, columns=('fullpath'), displaycolumns='', show='tree', pad=5)
        ysb = ttk.Scrollbar(frameTree, orient=VERTICAL, command=self.tree.yview)
        self.tree['yscroll'] = ysb.set
        self.tree.heading('#0', anchor=W)
        self.tree.pack(side=LEFT, fill=BOTH, expand=Y)
        ysb.pack(side=RIGHT, fill=Y)
        
        self.tree.bind('<<TreeviewOpen>>', self._update_tree)
        self.tree.bind('<<TreeviewSelect>>', self.updatelabel)
        self.master.bind('<Escape>',self.clickCANCEL)
        self._populate_root()
        
        # 하단 확인/취소 버튼
        frameButtons = ttk.Frame(self.master, pad=5)
        ttk.Button(frameButtons, text='취소',command=self.clickCANCEL).pack(side=RIGHT)
        ttk.Button(frameButtons, text='확인',command=self.clickOK).pack(side=RIGHT)
        frameButtons.pack(side=BOTTOM, fill=BOTH)

        self.findInitialDir(initialdir)
        self.master.focus_set()
        self.master.transient(master)
        self.master.grab_set()
        master.wait_window(self.master)

    def quit_process(self):
        ## 서브 다이얼로그 종료
        self.master.destroy()
        return self.result

    def findInitialDir(self, init):
        path_components = os.path.abspath(init.decode()).split(os.sep)
        parent, old_parent = '', None
        for path_com in path_components:
            if old_parent <> parent:
                old_parent = parent
                children = self.tree.get_children(parent)
                for child in children:
                    if self.tree.item(child)['text'] == path_com:
                        parent = child
                        self.tree.see(child)
                        self.tree.focus(child)
                        self.tree.selection_set(child)
                        self._update_tree()
                        break

    def updatelabel(self, event):
        curitem = self.tree.focus()
        self.stringDir.set(self.tree.set(curitem, 'fullpath'))

    def clickOK(self):
        self.result = self.stringDir.get()
        self.master.destroy()

    def clickCANCEL(self, event=None):
        self.result = ''
        self.master.destroy()

    def _populate_root(self):
        for dir in [c+':\\' for c in 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' if os.path.isdir(c+':\\')]:
            dir = os.path.abspath(dir)
            parent = self.tree.insert('', END, text=os.path.splitdrive(dir)[0], values=[dir])
            self._populate_tree(parent, dir, os.listdir(dir))
                 
    def _populate_tree(self, parent, fullpath, children):
        # parent   - id of node acting as parent
        # fullpath - the parent node's full path
        # children - list of files and sub-directories belonging to the 'parent' node
        for child in children:
            # build child's fullpath
            try:
                child = child.decode()
            except:
                pass
            cpath = os.path.join(fullpath, child)
     
            if os.path.isdir(cpath):
                # directory - only populate when expanded (see _create_treeview() 'bind')
                cid =self.tree.insert(parent, END, text=child, values=[cpath])
                # add 'dummy' child to force node as expandable
                self.tree.insert(cid, END, text='dummy')
                 
    def _update_tree(self, event=None): #@UnusedVariable
        # user expanded a node - build the related directory
        nodeId = self.tree.focus()      # the id of the expanded node
        if self.tree.parent(nodeId):    # not at root
            topChild = self.tree.get_children(nodeId)[0]
            # if the node only has a 'dummy' child, remove it and build new directory; skip if the node is already populated
            if self.tree.item(topChild, option='text') == 'dummy':
                self.tree.delete(topChild)
                path = self.tree.set(nodeId, 'fullpath')
                try:
                    self._populate_tree(nodeId, path, os.listdir(path))
                except:
                    pass

class SubDialog:
    
    def add_folder(self, initialdir):
        fd = FolderDialog(self.master, initialdir)
        result = fd.result
        del fd
        return result

    def __init__(self, master, parent):
        self.master = Toplevel(master)
        try:
            self.master.iconbitmap(app_icon)
        except:
            pass
        self.master.protocol('WM_DELETE_WINDOW', self.quit_process)
        self.parent = parent
        #self.params = config.parameters
        self.params = [('Source','KOMPSAT Source Directory','DIR'), ('Output','Output Directory','DIR')]
        self.parameters_help = [('Source','KOMPSAT 소스 경로 입력',(r'C:\TEST\K2', r'C:\TEST\K3')), ('Output','결과물의 저장 경로 입력',(r'C:\TEST\K2OUTPUT', r'C:\TEST\K3OUTPUT'))]
        
        ## 노트북 (탭윈도우)
        notebook_main = ttk.Notebook(self.master, padding=5, height=0)

        ## 배치 작업 추가 프레임 (노트북 탭1/2)
        frame_Batch = Frame(notebook_main, padx=10, pady=5)
        ttk.Button(frame_Batch, text='CSV 파일 선택', command=self.Add_BatchJobs).pack(side=TOP, fill=BOTH)
        CSV_Help = '배치 작업을 위해서는 CSV 파일을 작성하여 사용하십시오.\n\n지원 형식은 다음과 같습니다.\n\n1행: 다음과 같은 파라메터 명이 입력되어야 합니다.\n  '
        CSV_Help += ', '.join(map(lambda x: x[0], self.parameters_help))
        CSV_Help += '\n2행~ : 파라메터에 들어가는 값이 입력되어야 합니다.\n  '
        CSV_Help += '\n  '.join(map(lambda x: str(self.parameters_help.index(x)+1)+") "+ x[0] + "Field - " + x[1], self.parameters_help))
        CSV_Help += '\n\n다음은 CSV 파일 내용의 예시입니다:\n  '
        CSV_Help += ','.join(map(lambda x: x[0], self.parameters_help))
        for i in range(len(map(lambda x: x[2], self.parameters_help)[0])):
            CSV_Help += '\n  ' + ','.join(map(lambda x:x[2][i], self.parameters_help))
        Label(frame_Batch, justify=LEFT, pady=5, text=CSV_Help).pack(side=LEFT)
        
        ## 단일 작업 추가 프레임 (노트북 탭2/2)
        frame_Add = Frame(notebook_main, padx=10)
        self.frame_dict = dict()
        self.str_dict = dict()
        self.entry_dict = dict()
        self.command_dict = dict()
        for param_name, param_desc, param_type in self.params:
            self.frame_dict[param_name] = Frame(frame_Add, pady=5)
            self.frame_dict[param_name].pack(side=TOP, fill=X)
            Label(self.frame_dict[param_name], text=param_desc+' ').pack(side=LEFT)
            self.str_dict[param_name]=StringVar(value='')
            if param_type[:3] == 'CMB':
                self.entry_dict[param_name]=ttk.Combobox(self.frame_dict[param_name], textvariable=self.str_dict[param_name])
                self.entry_dict[param_name]['values'] = param_type.split('|')[1:]
                self.entry_dict[param_name].current(0)
                self.entry_dict[param_name].pack(side=LEFT, expand=YES, fill=BOTH)
            else:
                self.entry_dict[param_name]=ttk.Entry(self.frame_dict[param_name], textvariable=self.str_dict[param_name])
                self.entry_dict[param_name].pack(side=LEFT, expand=YES, fill=BOTH)
                ttk.Button(self.frame_dict[param_name], text='찾기', command=lambda p1=param_name, p2=param_type: self.set_parameter(p1, p2)).pack(side=LEFT)
        
        ## 단일 작업 추가 프레임 내부의 하단 프레임
        frame_Bottom = Frame(frame_Add, pady=5)
        frame_Bottom.pack(side=BOTTOM, fill=BOTH)
        ttk.Button(frame_Bottom, text='작업 추가', command=self.Add_SingleJob).pack(fill=BOTH)		
        
        ## 노트북에, 단일 작업 추가 프레임과 배치 작업 추가
        notebook_main.add(frame_Add, text=' 단일 작업 추가 ')
        notebook_main.add(frame_Batch, text=' 배치 작업 추가 ')
        notebook_main.pack(side=TOP, fill=BOTH)
        
        def handle_return_key(event=None):
            notebook_index = notebook_main.index(notebook_main.select())
            if notebook_index == 0:
                self.Add_SingleJob()
            else:
                self.Add_BatchJobs()
            
        self.master.focus_set()
        self.master.bind('<Return>', handle_return_key)

    def set_parameter(self, param_name, param_type):
        global lastdir
        self.parent.tkDialogOpened = True
        if param_type == 'DIR':
            f = self.add_folder(initialdir=lastdir)
            if f <> '':
                self.str_dict[param_name].set(f)
                lastdir = f
                if param_name == 'Source':
                    self.str_dict['Output'].set(os.path.normpath(f) + '_PS')
        elif param_type == 'FILE':
            f = askopenfilename(initialdir=lastdir, title='파일을 선택하십시오', parent=self.master)
            if f <> '':
                self.str_dict[param_name].set(f)
                lastdir = os.path.dirname(f)
        self.parent.tkDialogOpened = False		

    def Add_SingleJob(self, event=None):
        ## (단일) 작업 추가 버튼 클릭시 실행
        if "" not in self.str_dict.values():
            self.AddJob()
            self.quit_process()

    def Add_BatchJobs(self, event=None):
        ## (배치) 작업 추가 버튼 클릭시 실행
        global lastdir
        self.parent.tkDialogOpened = True
        f = askopenfilename(initialdir=lastdir, title='파일을 선택하십시오.', parent=self.master, filetypes=[('모든 파일','*.*'),('CSV 파일','*.csv')])
        self.parent.tkDialogOpened = False
        if f <> '':
            csv_file = open(f)
            try:
                csv_reader = csv.reader(csv_file)
                header = []
                failed = []
                success = 0
                num = 1
                for csv_line in csv_reader:
                    if len(header) == 0:
                        header = csv_line
                    else:
                        for param_name in map(lambda x: x[0], self.params):
                            self.str_dict[param_name].set(csv_line[header.index(param_name)])
                        result = self.AddJob()
                        if result == 0:
                            success += 1
                        else:
                            failed.append(num)
                    num += 1
            except:
                tkMessageBox.showerror('ERROR', 'CSV 파일을 읽는 중 오류가 발생하였습니다.')
            csv_file.close()
            if len(failed) > 0:
                tkMessageBox.showinfo('INFO', '추가한 작업의 수: %d\n추가에 실패한 행 번호는 다음과 같습니다:\n%s\n확인해보시기 바랍니다.(1행은 파라메터명 입력 행)' % (success, failed))
            else:
                tkMessageBox.showinfo('INFO', '추가한 작업의 수: %d' % success)
            self.quit_process()

    def AddJob(self):
        ## 작업 추가
        now = time.localtime()
        jobid = '%04d%02d%02d%02d%02d%02d' % (now.tm_year, now.tm_mon, now.tm_mday, now.tm_hour, now.tm_min, now.tm_sec)
        try:
            tmp = self.str_dict[self.params[0][0]].get().split('/')[-1]
            tmp = tmp.split('\\')[-1]
            jobid += '_' + tmp
            
            ## 파일명 중복체크
            while os.path.isfile(self.parent.workdir + '\\' + jobid) or os.path.isfile(self.parent.subdir[self.parent.jobtypes[1]] + '\\' + jobid) or os.path.isfile(self.parent.subdir[self.parent.jobtypes[2]] + '\\' + jobid) or os.path.isfile(self.parent.subdir[self.parent.jobtypes[3]] + '\\' + jobid):
                jobid += "'"
            paraminfo = 'JobID: ' + jobid
            for param_name in map(lambda x: x[0], self.params):
                paraminfo += '\n' + param_name + ': ' + self.str_dict[param_name].get()
            f = open(self.parent.workdir + '\\' + jobid, 'w')
            f.write(paraminfo)
            f.close()

            shutil.move(self.parent.workdir + '\\' + jobid, self.parent.subdir[self.parent.jobtypes[1]])
            result = 0
        except:
            result = -1
        return result

    def show(self):
        ## 현재 창 모달화
        self.master.grab_set()
        self.master.wait_window()
        

    def quit_process(self):
        ## 서브 다이얼로그 종료
        self.parent.addjobdialog = None
        self.master.destroy()
			
class MainApp:
    def __init__(self):
        self.master = Tk()
        try:
            self.master.iconbitmap(app_icon)
        except:
            pass
        self.master.protocol('WM_DELETE_WINDOW', self.quit_process)
        
        self.jobtypes = ['running','waiting','completed','failed']

        ## 윈도우 설정
        self.title = 'EASI Launcher App'
        self.version = 'Unknow version'
        try:
            self.title = app_title
            self.version = app_version
        except:
            pass
        self.appsize = '600x400'
        self.text_font = 'Dotum 9 normal'
        self.master.option_add('*Font', self.text_font)
        self.title_font = 'Arial 15 bold'
        self.title_bg = '#bbbbbb'

        ## APP 제목 표시 및 크기 실제 적용
        self.master.title(self.title)
        self.master.geometry(self.appsize)

        ## 종류별 작업파일 및 디렉토리 변수 초기화
        self.new_jobs = dict()
        self.old_jobs = dict()
        self.workdir = r'WORK'
        self.subdir = dict()
        for jobtype in self.jobtypes:
            self.new_jobs[jobtype] = []
            self.old_jobs[jobtype] = []
            self.subdir[jobtype] = self.workdir + '\\' + jobtype.upper()
            
        self.easi = None ## EASI 프로세스 변수
        self.addjobdialog = None ## 서브 창 관리 변수
        self.tkDialogOpened = False	## 파일/경로 선택 창이 열렸을 때 화면 갱신을 정지시키기 위한 변수

        ## 첫 번째 프레임(제목 표시 영역)
        frame_top = Frame(self.master, background=self.title_bg)
        frame_top.pack(side=TOP, fill=X)
        Label(frame_top, text=self.title, background=self.title_bg, font=self.title_font, anchor=W, padx=10, pady=15).pack(side=LEFT, fill=X, expand=YES)
        Label(frame_top, text=self.version, background=self.title_bg, padx=50).pack(side=RIGHT)

        ## 두 번째 프레임(실행 중 작업 표시 영역)
        jobtype = self.jobtypes[0]
        jobtype_text = '실행중인 작업 '
        frame_running = Frame(self.master, pady=10, padx=5)
        frame_running.pack(side=TOP, fill=X)
        Label(frame_running, text='실행중인 작업 ').pack(side=LEFT)
        self.strvar_running = StringVar(value='')
        entry_running = ttk.Entry(frame_running, state='readonly', textvariable=self.strvar_running)
        entry_running.bind('<Button-3>', lambda e, j=jobtype:self.open_popup(e,j))
        entry_running.bind('<Double-Button-1>', lambda e, j=jobtype:self.see_job(j))
        entry_running.pack(side=LEFT, expand=YES, fill=BOTH)
        ttk.Button(frame_running, text='강제종료', command=lambda j=jobtype:self.del_job(j)).pack(side=RIGHT)
        
        frame_dict = dict()
        self.listbox_dict = dict()
        scrollbar_dict = dict()
        self.popupmenu_dict = dict()
        
        ## 실행 작업 오른쪽 클릭시 나타나는 팝업메뉴
        self.popupmenu_dict[jobtype] = Menu(self.master, tearoff=0)
        self.popupmenu_dict[jobtype].add_command(label='정보', command=lambda j=jobtype:self.see_job(j))
        self.popupmenu_dict[jobtype].add_command(label='종료', command=lambda j=jobtype:self.del_job(j))
        self.popupmenu_dict[jobtype + 'fix'] = [False, False] ## 메뉴 항목별로 Enable/Disable 고정 여부 설정
            
        ## 세 번째 프레임(작업 목록 표시 영역)
        frame_joblist=Frame(self.master)
        frame_joblist.pack(side=TOP, padx=3, pady=3, fill=BOTH, expand=YES, anchor=N)

        ## 세 번째 프레임 내의 작업목록 프레임
        for jobtype in self.jobtypes[1:]:
            frame_dict[jobtype] = Frame(frame_joblist)
            frame_dict[jobtype].pack(side=LEFT, padx=3, pady=3, expand=YES, fill=BOTH)
            if jobtype == self.jobtypes[1]:
                jobtype_text = '대기 작업'
            elif jobtype == self.jobtypes[2]:
                jobtype_text = '완료 작업'
            elif jobtype == self.jobtypes[3]:
                jobtype_text = '실패 작업'
            Label(frame_dict[jobtype], text=jobtype_text, pady=5).pack(side=TOP)
            if jobtype == self.jobtypes[1]:
                frame_dict[jobtype+'btn0'] = Frame(frame_dict[jobtype])
                frame_dict[jobtype+'btn0'].pack(side=BOTTOM, padx=0, pady=0, expand=NO, fill=BOTH)
                ttk.Button(frame_dict[jobtype+'btn0'], text='추가', command=self.add_job).pack(side=LEFT, padx=0, pady=0, expand=YES, fill=BOTH)
            frame_dict[jobtype+'btn'] = Frame(frame_dict[jobtype])
            frame_dict[jobtype+'btn'].pack(side=BOTTOM, padx=0, pady=0, expand=NO, fill=BOTH)
            ttk.Button(frame_dict[jobtype+'btn'], text='삭제', command=lambda j=jobtype:self.del_job(j)).pack(side=LEFT, padx=0, pady=0, expand=YES, fill=BOTH)
            ttk.Button(frame_dict[jobtype+'btn'], text='정보', command=lambda j=jobtype:self.see_job(j)).pack(side=LEFT, padx=0, pady=0, expand=YES, fill=BOTH)
            scrollbar_dict[jobtype+'x'] = ttk.Scrollbar(frame_dict[jobtype], orient='horizontal')
            scrollbar_dict[jobtype+'x'].pack(side=BOTTOM,fill=X)
            scrollbar_dict[jobtype+'y'] = ttk.Scrollbar(frame_dict[jobtype])
            scrollbar_dict[jobtype+'y'].pack(side=RIGHT,fill=Y)
            self.listbox_dict[jobtype] = Listbox(frame_dict[jobtype], activestyle='none', selectmode='extended', xscrollcommand=scrollbar_dict[jobtype+'x'].set, yscrollcommand=scrollbar_dict[jobtype+'y'].set)
            scrollbar_dict[jobtype+'y'].config(command=self.listbox_dict[jobtype].yview)
            scrollbar_dict[jobtype+'x'].config(command=self.listbox_dict[jobtype].xview)
            self.listbox_dict[jobtype].bind('<Double-Button-1>', lambda e, j=jobtype: self.see_job(j))
            self.listbox_dict[jobtype].bind('<Button-3>', lambda e, j=jobtype: self.open_popup(e,j))
            self.listbox_dict[jobtype].pack(side=TOP, expand=YES, fill=BOTH)
            
            ## 작업 목록 오른쪽 클릭시 나타나는 팝업메뉴
            self.popupmenu_dict[jobtype + 'fix'] = [] ## 메뉴 항목별로 Enable/Disable 고정 여부 설정
            self.popupmenu_dict[jobtype] = Menu(self.master, tearoff=0)
            if jobtype == self.jobtypes[1]:
                self.popupmenu_dict[jobtype].add_command(label='추가', command=self.add_job)
                self.popupmenu_dict[jobtype + 'fix'] = [True]
            self.popupmenu_dict[jobtype].add_command(label='정보', command=lambda j=jobtype: self.see_job(j))
            self.popupmenu_dict[jobtype].add_command(label='삭제', command=lambda j=jobtype: self.del_job(j))
            self.popupmenu_dict[jobtype + 'fix'] += [False, False]

        ## 작업 디렉토리 체크
        for jobtype in self.jobtypes:
            target_dir = self.subdir[jobtype]
            if not os.path.exists(target_dir):
                os.makedirs(target_dir)

        ## 작업 모니터링 시작
        self.master.bind('<Return>', self.add_job)
        self.master.bind('<space>', self.add_job)
        self.task()

        ## APP MAINLOOP
        self.master.mainloop()
		
    def open_popup(self, event, jobtype):
        ## 실행 작업 팝업 메뉴 호출
        if (jobtype in self.jobtypes[1:4] and len(self.listbox_dict[jobtype].curselection()) > 0) or (jobtype == self.jobtypes[0] and self.strvar_running.get() != ''):
                itemstate = NORMAL
        else:
                itemstate = DISABLED	
        for num in range(len(self.popupmenu_dict[jobtype + 'fix'])):
            if self.popupmenu_dict[jobtype + 'fix'][num] == False:
                self.popupmenu_dict[jobtype].entryconfigure(num, state=itemstate)
        self.popupmenu_dict[jobtype].post(event.x_root, event.y_root)
        
    def see_job(self, jobtype):
        ## 작업 확인
        target_dir = self.subdir[jobtype]
        if jobtype == self.jobtypes[0]:
            jobname = self.strvar_running.get()
            if jobname == '':
                return
        else:
            target = self.listbox_dict[jobtype]
            if len(target.curselection()) > 0:
                jobname = target.get(target.curselection()[0])
            else:
                return
        jobname = target_dir + '\\' + jobname
        subprocess.Popen(['notepad.exe', jobname])
        

    def del_job(self, jobtype):
        ## 작업 삭제
        target_dir = self.subdir[jobtype]
        if jobtype == self.jobtypes[0]:
            if self.strvar_running.get() != '' and tkMessageBox.askokcancel('강제 종료 확인', '실행 중인 작업을 강제 종료하시겠습니까?'):
                self.kill_job()
                self.easi = None
        else:
            target = self.listbox_dict[jobtype]
            if len(target.curselection()) > 0 and tkMessageBox.askokcancel('작업 정보 삭제', str(len(target.curselection())) + '개의 정보를 삭제하시겠습니까?'):
                for i in target.curselection()[-1::-1]:
                    os.remove(target_dir + '\\' + target.get(i))

    def remove_runningjob(self):
        ## 실행 작업을 실패로 이동
        jobname = self.strvar_running.get()
        if jobname != '':
            try:
                shutil.move(self.subdir[self.jobtypes[0]] + '\\' + jobname, self.subdir[self.jobtypes[3]])
            except:
                pass
    
    def kill_job(self):
        ## 강제 종료
        self.easi.kill()
        self.remove_runningjob()

    def add_job(self, event=None):
        ## 작업 추가 윈도우 오픈
        if self.addjobdialog == None:
            self.addjobdialog = SubDialog(self.master, self)
            ## 서브 창 모달화
            self.addjobdialog.show()
            
    def task(self):
        ## 작업 폴더 내 변동 사항 모니터링
        if self.tkDialogOpened == False:
            for jobtype in self.jobtypes:
                self.new_jobs[jobtype] = os.listdir(self.subdir[jobtype])
                if self.old_jobs[jobtype] != self.new_jobs[jobtype]:
                    self.old_jobs[jobtype] = self.new_jobs[jobtype]
                    self.update_joblist(jobtype)
                    
        ## EASI 창 활성화 확인
        if self.easi == None:
            #self.easi = subprocess.Popen([config.easi_path, 'R "monitor"'])
            self.easi = subprocess.Popen([easi_path, 'KPANSHARP.py'])
        elif self.easi.poll() is not None:
            self.kill_job()
            self.quit_process()
            self.easi = None
        self.master.after(1000,self.task) ## 일정시간 이후, 재호출

    def update_joblist(self, jobtype):
        ## 작업 목록 업데이트
        if jobtype == self.jobtypes[0]:
            self.strvar_running.set('')
            if len(self.new_jobs) > 0:
                try:
                    self.strvar_running.set(self.new_jobs[jobtype][0].decode())
                except:
                    pass
        else:
            target = self.listbox_dict[jobtype]
            num = 0
            target.delete(num, target.size())
            for target_file in self.new_jobs[jobtype]:
                target.insert(num, target_file.decode())
                num += 1
                
    def quit_process(self):
        ## 앱 종료 처리
        if tkMessageBox.askokcancel("종료 확인", '종료하시겠습니까?'):
            self.kill_job()
            self.master.destroy()
            try:
                os.remove('PRM.PRM')
            except:
                pass

myapp = MainApp()